<template>
  <div v-loading="loading">
    <el-upload where="portfolio" multiple />
    <Feed :counter="true" :data="media" :moderate="true" />
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, useContext } from '@nuxtjs/composition-api'
import { MediaFileFragment } from '~/sdk/types'
import { useMediaSubscription, useDeleteMediaMutation } from '~/sdk/hooks'

import elCheckbox from '@/components/element/Checkbox.vue'
import elDialog from '@/components/element/Dialog.vue'
import elUpload from '@/components/element/Upload.vue'
import Button from '@/components/ui/Button.vue'
import Feed from '@/components/ui/Feed.vue'
// vue touch
import Vue from 'vue'
import Vue2TouchEvents from 'vue2-touch-events'
Vue.use(Vue2TouchEvents)

export default defineComponent({
  name: 'FeedPage',
  components: { elUpload, elCheckbox, elDialog, Button, Feed },
  setup(_, { root }) {
    const { app } = useContext()
    const modals = ref({
      delete: false
    })
    const media = ref<MediaFileFragment[]>([])
    const { onResult, loading } = useMediaSubscription({
      where: {
        album_id: { _is_null: true },
        event_id: { _is_null: true },
        user_id: { _eq: root.$accessor.auth.userId }
      },
      limit: 10000,
      offset: 0
    })
    onResult(result => {
      if (result?.data?.media_files) {
        media.value = result.data.media_files
      }
    })

    const MediaEditCheckBox = ref(false)
    const MediaEditList = ref([])
    const onClickMediaEdit = () => {
      if (MediaEditCheckBox.value !== false) {
        MediaEditCheckBox.value = false
        MediaEditList.value = []
      } else {
        MediaEditCheckBox.value = true
      }
    }

    // delete images

    const { mutate: deleteMutate } = useDeleteMediaMutation({})
    const deleteMediaItems = async (items: any) => {
      try {
        await items.forEach((i: any) => {
          deleteMutate({ id: i })
        })
      } catch (err) {
        root.$message.error('Что-то пошло не так...')
      } finally {
        root.$message.success('Изображения успешно удалены')
      }
      modals.value.delete = false
      MediaEditList.value = []
      MediaEditCheckBox.value = false
    }

    return {
      media,
      loading,
      modals,

      onClickMediaEdit,
      MediaEditList,
      MediaEditCheckBox,
      deleteMediaItems
    }
  }
})
</script>

<style lang="scss" scoped>
@import '~/assets/scss/variables';

$height: 230px;
.feed {
  &-panel {
    position: fixed;
    left: 50%;
    transform: translateX(-50%);
    bottom: 30px;
    display: flex;
    justify-content: center;
    z-index: 999;
    > * {
      margin-left: 5px;
      margin-right: 5px;
    }
  }
  &-cancel {
    background: $--color-success;
    box-shadow: 0px 3px 6px #00000029;
    border: 0px;
    outline: none;
    border-radius: 3px;
    width: 50px;
    height: 50px;
    display: flex;
    align-items: center;
    justify-content: center;
    cursor: pointer;
    svg {
      width: 16px;
      height: 16px;
      fill: $--color-bg;
    }
    @media (min-width: 991.98px) {
      padding: 20px 30px;
      width: auto;
      height: auto;
    }
  }
  &-delete {
    background: $--color-danger;
    box-shadow: 0px 3px 6px #00000029;
    border: 0px;
    outline: none;
    border-radius: 3px;
    letter-spacing: 0.8px;
    color: $--color-bg;
    font-weight: bold;
    text-transform: uppercase;
    font-size: 16px;
    line-height: 20px;
    cursor: pointer;

    width: 50px;
    height: 50px;
    display: flex;
    align-items: center;
    justify-content: center;
    svg {
      display: block;
      width: 18px;
      height: 18px;
      fill: #fff;
    }
    span {
      display: none;
    }
    @media (min-width: 991.98px) {
      padding: 20px 40px;
      min-width: 300px;
      width: auto;
      height: auto;
      svg {
        display: none;
      }
      span {
        display: block;
      }
    }
  }
  &-edit {
    position: absolute;
    left: 0px;
    right: 0px;
    top: 0px;
    bottom: 0px;
    display: flex;
    font-size: 0px;
    z-index: 99;
    ::v-deep {
      .el-checkbox {
        margin: 0px;
        padding: 0px;
        font-size: 0px;
        display: flex;
        align-items: flex-start;
        justify-content: flex-end;
        flex: 1;
        padding: 15px;
        &__inner {
          margin: 0px;
          &::after {
            border: 2px solid #495271;
            border-left: 0;
            border-top: 0;
          }
        }
        &__label {
          display: none;
        }
        &__input.is-checked {
          .el-checkbox__inner {
            background-color: #00ffb3;
          }
        }
      }
    }
  }
  &-info {
    font-size: 0px;
    display: flex;
    flex-direction: column;
    margin-bottom: 30px;
    @media (min-width: 1199.98px) {
      flex-direction: row;
      align-items: flex-end;
    }
    &__title {
      font-size: 35px;
      line-height: 35px;
      letter-spacing: -0.88px;
      color: #ffffff;
      margin-right: 30px;
    }
    &__descr {
      font-weight: 500;
      font-size: 18px;
      line-height: 23px;
      letter-spacing: 0px;
      color: #9badd6;
    }
  }
}

.media {
  display: grid;
  grid-template-columns: repeat(12, 1fr);
  grid-template-rows: repeat(2, 1fr);
  grid-gap: 2px;
  font-size: 0px;
  margin-left: -30px;
  margin-right: -30px;
  margin-bottom: -30px;
  $self: &;
  @media (min-width: 1199.98px) {
    grid-gap: 35px;
    margin-left: 0px;
    margin-right: 0px;
    margin-bottom: 0px;
    grid-gap: 20px;
  }
  &__item {
    grid-column: span 6;
    grid-row: span 1;
    position: relative;
    display: flex;
    &::v-deep {
      .blurhash {
        flex: 1;
      }
      img {
        object-fit: cover;
        border-radius: 2px;
        width: 100%;
        height: 180px;
        border-radius: 2px;
        @media (min-width: 1199.98px) {
          height: 280px;
        }
      }
    }

    @media (min-width: 1199.98px) {
      grid-column: span 4;
      grid-row: span 1;
      &:nth-child(9n + 1),
      &:nth-child(9n + 5) {
        grid-column: span 8;
        grid-row: span 2;
      }
    }
  }

  &.large {
    #{ $self }__item {
      @media (min-width: 1199.98px) {
        grid-column: span 3;
        grid-row: span 1;
        &:nth-child(12n + 1),
        &:nth-child(12n + 7) {
          grid-column: span 6;
          grid-row: span 2;
        }
        &:nth-child(12n + 2),
        &:nth-child(12n + 5) {
          grid-column: span 3;
          grid-row: span 2;
        }
      }
    }
  }
}
</style>
